#!/usr/bin/perl -w
#Translated from BASIC by basic2pl

##############################################################################
# Main program
#
package Moonph;
require Exporter;

@ISA = qw(Exporter);
@EXPORT_OK = qw(&getph @moonph @myhash);

sub getph
{

L10:    ; #           MOON EFFECTS by Bradley E. Schaefer
L30:    $p2 = 2*3.14159;
        ; #   Radians in a full circle
; # L40:    print "Year, month, day" . "? ";
; #        $input_tmp = <>;
; #                chomp($input_tmp);
; #                ($y, $m, $d) = split(/\s*,\s*/, $input_tmp);
($y) = shift;
($m) = shift;
($d) = shift;
($h) = shift;


$f_day = .04167; # each hour is this fracition of a day
$utc_offset = $h * $f_day;


; # print $utc_offset;


L50:    $yy = $y-int((12-$m)/10);
L60:    $mm = $m+9;
        if ($mm >= 12) {
            $mm = $mm-12;
        }
L70:    $k1 = int(365.25*($yy+4712));
L80:    $k2 = int(30.6*$mm+0.5);
L90:    $k3 = int(int(($yy/100)+49)*0.75)-38;
L100:   $j = $k1+$k2+$d+59;
        ; #    JD for dates in Julian calendar
L110:   if ($j > 2299160) {
            $j = $j-$k3;
            ; #   For Gregorian calendar
        }
L120:   ; #   J is the Julian date at 12h UT on day in question
L130:   ; # 
L140:   ; #   Calculate illumination (synodic) phase
L150:   $v = ($j-2451550.1)/29.530588853;

; # &normalize_v;
($v) = &normalize_v($v);

AL150:  ;
        $ip = $v;
L160:   $ag = $ip*29.53;
        ; #   MoonREMs age in days
L170:   $ip = $ip*$p2;
        ; #      Convert phase to radians
L180:   ; # 
L190:   ; #   Calculate distance from anomalistic phase
L200:   $v = ($j-2451562.2)/27.55454988;

; # &normalize_v;
($v) = &normalize_v($v);

AL200:  ;
        $dp = $v;
L210:   $dp = $dp*$p2;
        ; #    Convert to radians
L220:   $di = 60.4-3.3*$cos[$dp]-0.6*$cos[2*$ip-$dp]-0.5*$cos[2*$ip];
L230:   ; # 
L240:   ; #   Calculate latitude from nodal (draconic) phase
L250:   $v = ($j-2451565.2)/27.212220817;

 
; # &normalize_v;
($v) = &normalize_v($v);

AL250:  ;
        $np = $v;
L260:   $np = $np*$p2;
        ; #   Convert to radians
L270:   $la = 5.1*$sin[$np];
L280:   ; # 
L290:   ; #   Calculate longitude from sidereal motion
L300:   $v = ($j-2451555.8)/27.321582241;

($v) = &normalize_v($v);

AL300:  ;
        $rp = $v;
L310:   $lo = 360*$rp+6.3*$sin[$dp]+1.3*$sin[2*$ip-$dp]+0.7*$sin[2*$ip];
L320:   ; # 
;# add in the utc offset to get the proper age of moon in your timezone
$ag = $ag+$utc_offset;
$ag = sprintf("%1.0f",$ag);
; # print $ag;

; # L330:   print("Moon's age from new (days):", $ag,' ', "\n");
@moonph = sprintf("Moon's age from new (days):".$ag.' '. "\n");
; # L340:   print("Distance (Earth radii):    ", $di,' ', "\n");
; # L350:   print("Ecliptic latitude (degrees):", $la,' ', "\n");
; # L360:   print("Ecliptic longitude (degrees):", $lo,' ', "\n");
; # L370:   print("", "\n");
; #         print "Continue (y or n)" . "? ";
; #                 $input_tmp = <>;
; #                 chomp($input_tmp);
; #                 $q_str = $input_tmp;
; #         L380:   if ($q_str ne "N" && $q_str ne "n") {
; #                     goto L40;
; #                 }
return (@moonph);
; # L390:   exit;
}
return 1;
sub normalize_v
{
; #       Normalize values to range 0 to 1
my $v;
$v = shift;
   $v = $v-int($v);
        if ($v < 0) {
            $v = $v+1;
        }
return ($v);
}

L430:   ; # 
L440:   ; #     This program helps anyone who needs to know the MoonREMs 
L450:   ; #     phase (age), distance, and position along the ecliptic on
L460:   ; #     any date within several thousand years in the past or future.
L470:   ; #     To illustrate its application, Bradley Schaefer applied it 
L480:   ; #     to a number of famous events influenced by the Moon in 
L490:   ; #     World War II.  His article appeared in Sky & Telescope for
L500:   ; #     April 1994, page 86.
